<?php

namespace App\Controllers\Admin\Cloudflare;

use App\Libraries\MyCloudflare\Record;
use App\Models\Cloudflare\RecordModel;
use CodeIgniter\HTTP\RedirectResponse;
use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;

class RecordController extends CloudflareController
{
    private $_myLibrary = null;
    private $_account_entity = null;
    private $_zone_entity = null;
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->class_name = "Record";
        $this->class_path .= $this->class_name;
        $this->title      = lang("{$this->class_path}.title");
        helper($this->class_path);
    }
    final protected function getModel(): RecordModel
    {
        if ($this->_model === null) {
            $this->_model = new RecordModel();
        }
        return $this->_model;
    }
    final protected function getMyLibrary(): Record
    {
        if ($this->_myLibrary === null) {
            $this->_myLibrary = new Record($this->_account_entity, $this->_zone_entity);
        }
        return $this->_myLibrary;
    }
    protected function getFormFieldOption(string $field, array $options = []): array
    {
        switch ($field) {
            case $this->getModel()::PARENT:
                $this->getZoneModel()->where('status', DEFAULTS['STATUS']);
                $options[$field] = [
                    DEFAULTS['EMPTY'] => lang($this->_className . '.label.' . $field) . ' 선택',
                    ...$this->getZoneModel()->getFormFieldOption($field, $options),
                ];
                break;
            default:
                $options = parent::getFormFieldOption($field, $options);
                break;
        }
        return $options;
    }
    //전송된 데이터
    protected function getFormData(string $field, array $formDatas): array
    {
        switch ($field) {
            case 'hosts':
                $formDatas[$field] = explode("\n", $this->request->getVar($field));
                if (!is_array($this->formDatas[$field]) || !count($this->formDatas[$field])) {
                    throw new \Exception("호스트명이 정의되지 않았습니다.");
                }
                break;
            default:
                $formDatas = parent::getFormData($field, $formDatas);
                break;
        }
        return $formDatas;
    }
    protected function create_init(): void
    {
        $this->action        = 'create';
        $this->fields        = [$this->getModel()::PARENT, 'type', 'content', 'proxied', 'hosts'];
        $this->filter_fields = [$this->getModel()::PARENT, 'type', 'proxied'];
        $this->field_rules   = $this->getModel()->getFieldRules($this->fields);
        $this->field_options = $this->getFormFieldOptions();
        $this->getModel()->setAction($this->action);
    }
    protected function create_validate(): void
    {
        //hosts를 제외한 fields Valid처리
        $this->validateFormDatas(array_diff($this->fields, ['hosts']));
    }
    protected function create_process(): void
    {
        $this->_zone_entity    = $this->getZoneModel()->getEntityByPK($this->formDatas[$this->getModel()::PARENT]);
        $this->_account_entity = $this->getAccountModel()->getEntityByPK($this->_zone_entity->getParent());
        if ($this->_account_entity === null) {
            throw new \Exception("해당 계정정보를 찾을수 없습니다.");
        }
        //Record생성
        foreach ($this->formDatas['hosts'] as $host) {
            $this->getMyLibrary()->create($host, $this->formDatas);
        }
    }
    //수정
    protected function modify_init(): void {}
    //  리스트
    public function list_init(): void
    {
        $this->action          = 'index';
        $this->fields          = [$this->getModel()::PARENT, $this->getModel()::TITLE, 'type', 'content', 'ttl', 'proxied', 'locked', 'updated_at', 'created_at'];
        $this->filter_fields   = [$this->getModel()::PARENT, 'type', 'proxied'];
        $this->batchjob_fields = ['proxied'];
        $this->field_rules     = $this->getModel()->getFieldRules($this->fields);
        $this->field_options   = $this->getFormFieldOptions();
        $this->getModel()->setAction($this->action);
    }
}
